/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include "PluginModel.h"
#include "ServiceModel.h"

#include <algorithm>

namespace GB2 {


Service::Service(ServiceType t, const QString& _name, const QString& _desc, const QList<ServiceType>& _parentServices, ServiceFlags f)
: type(t), name(_name), description(_desc), parentServices(_parentServices), state(ServiceState_Disabled_New), flags(f)
{
}

void ServiceRegistry::_setServiceState(Service* s, ServiceState state)  
{
	assert(s->state!=state);

	ServiceState oldState = s->state;
	bool enabledBefore = s->isEnabled();
	s->state = state; 
	bool enabledAfter = s->isEnabled();
	s->serviceStateChangedCallback(oldState, enabledBefore!=enabledAfter);
	emit si_serviceStateChanged(s, oldState);
}

}//namespace

