/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_PLAIN_TEXT_FORMAT_H_
#define _GB2_PLAIN_TEXT_FORMAT_H_

#include <core_api/DocumentFormats.h>
#include <core_api/DocumentModel.h>

namespace GB2 {

class GB2_COREAPI_EXPORT PlainTextFormat : public DocumentFormat {
    Q_OBJECT
public:
	PlainTextFormat(QObject* p);

	virtual DocumentFormatId getFormatId() const {return BaseDocumentFormats::PLAIN_TEXT;}

	virtual const QString& getFormatName() const {return formatName;}

	virtual Document* createNewDocument(IOAdapterFactory* io, const QString& url, const QVariantMap& fs = QVariantMap());
	
	virtual Document* loadDocument(IOAdapter* io, TaskStateInfo& ti, const QVariantMap& fs, DocumentLoadMode mode = DocumentLoadMode_Whole);

	virtual void storeDocument(Document* d, TaskStateInfo& ts, IOAdapter* io);

	virtual bool checkRawData(const QByteArray& rawData) const;

    virtual int getFormatDetectionPriority() const {return -10;}

	static void storeRawData(const QByteArray& data, TaskStateInfo& ts, IOAdapter* io);

private:
	QString formatName;
};

}//namespace

#endif
