/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef VANDERWAALSSURFACE_H
#define VANDERWAALSSURFACE_H

#include "MolecularSurface.h"

namespace GB2 {

class GB2_COREAPI_EXPORT VanDerWaalsSurface : public MolecularSurface
{
public:
    VanDerWaalsSurface();
    virtual void calculate(const QList<SharedAtom>& atoms);
    virtual void calculate(const BioStruct3D& bioStruct);
};

class GB2_COREAPI_EXPORT VanDerWaalsSurfaceFactory : public MolecularSurfaceFactory {
public:
    virtual MolecularSurface *createInstance()const;
};

} // namespace GB2

#endif // VANDERWAALSSURFACE_H
