/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_DNASEQUENCE_SELECTION_H_
#define _GB2_DNASEQUENCE_SELECTION_H_

#include "LRegionsSelection.h"
#include "SelectionTypes.h"

namespace GB2 {

class DNASequenceObject;

class GB2_COREAPI_EXPORT DNASequenceSelection : public LRegionsSelection {
    
    Q_OBJECT

public:
	DNASequenceSelection(DNASequenceObject* _obj, QObject* p = NULL) : LRegionsSelection(GSelectionTypes::DNASEQUENCE, p), obj(_obj) {}
    const DNASequenceObject* getSequenceObject() const { return obj; }

private:
	DNASequenceObject* obj;
};

}//namespace

#endif
