/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_CREATE_OBJECT_RELATION_DIALOG_CONTROLLER_H_
#define _GB2_CREATE_OBJECT_RELATION_DIALOG_CONTROLLER_H_

#include <core_api/core_api.h>

#include <ui/ui_CreateObjectRelationDialog.h>

namespace GB2 {

class GObject;

class GB2_COREAPI_EXPORT CreateObjectRelationDialogController : public QDialog,  public Ui_CreateObjectRelationDialog {
    Q_OBJECT
public:
    CreateObjectRelationDialogController(GObject* obj, const QList<GObject*>& objects, 
                                        const QString& role, bool removeDuplicates, QWidget* p = NULL);

    GObject*        selectedObject;
    GObject*        assObj;
    QList<GObject*> objects;
    QString         role;
    bool            removeDuplicates;

public slots:
    virtual void accept();

};

} //namespace

#endif
