/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_SEQ_PASTER_WIDGET_CONTROLLER_H_
#define _GB2_SEQ_PASTER_WIDGET_CONTROLLER_H_

#include "ui/ui_SeqPasterWidget.h"

#include <core_api/core_api.h>
#include <datatype/DNASequence.h>

namespace GB2{

class GB2_COREAPI_EXPORT SeqPasterWidgetController : public QObject, public Ui::SeqPasterWidget {
    Q_OBJECT
public:
    SeqPasterWidgetController(QObject *p = NULL);

    QString validate(); 
    QWidget* getWidget() const {return w;}
    DNASequence getSequence() const {return resultSeq;}
    void disableCustomSettings();
    void setPreferredAlphabet(DNAAlphabet *alp);
private slots:
    void sl_currentindexChanged(const QString&);
private:
    DNAAlphabet *preferred;
    QWidget *w;
    DNASequence resultSeq;
};

}//ns

#endif
