/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_MSA_EDITOR_FACTORY_H_
#define _GB2_MSA_EDITOR_FACTORY_H_

#include <core_api/ObjectViewModel.h>

namespace GB2 {

class MultiGSelection;
class MSAColorSchemeRegistry;

class GB2_COREAPI_EXPORT MSAEditorFactory : public GObjectViewFactory {
    Q_OBJECT
public:
    MSAEditorFactory();
    
    virtual bool canCreateView(const MultiGSelection& multiSelection);

    virtual Task* createViewTask(const MultiGSelection& multiSelection, bool single = false);

    virtual bool isStateInSelection(const MultiGSelection& multiSelection, const QVariantMap& stateData);

    virtual Task* createViewTask(const QString& viewName, const QVariantMap& stateData);

    virtual bool supportsSavedStates() const {return true;}

    static const GObjectViewFactoryId ID;
};



} // namespace

#endif
