/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_TREE_VIEWER_STATE_H_
#define _GB2_TREE_VIEWER_STATE_H_

#include <core_api/LRegion.h>
#include <core_api/GObject.h>

#include <QtCore/QVariant>

namespace GB2 {

class TreeViewer;

class GB2_COREAPI_EXPORT TreeViewerState {
public:
    TreeViewerState(){}

	TreeViewerState(const QVariantMap& _stateData) : stateData(_stateData){}

	static QVariantMap saveState(TreeViewer* v);

	bool isValid() const;

	GObjectReference getPhyObject() const;

	void setPhyObject(const GObjectReference& ref);
	
	int getX() const;

	void setX(int x);

	int getY() const;

	void setY(int y);

	QVariantMap stateData;
};

} // namespace

#endif
