/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include <core_api/DocumentModel.h>
#include <core_api/ProjectModel.h>
#include <core_api/AppContext.h>
#include "AddDocumentTask.h"

namespace GB2
{

AddDocumentTask::AddDocumentTask( Document * _d ) :
Task( tr("Add document to the project: %1").arg(_d->getURLString()), TaskFlag_NoRun), d(_d)
{

}

Task::ReportResult AddDocumentTask::report() {
    Project * p = AppContext::getProject();
    if( p->isStateLocked() ) {
        return ReportResult_CallMeAgain;
    } else if (d!= NULL) {
		Document* sameURLDoc = p->findDocumentByURL(d->getURL());
		if (sameURLDoc!=NULL) {
			stateInfo.setError(tr("Document is already added to the project %1").arg(d->getURL().getURLString()));
		} else {
			p->addDocument( d );
		}
    } else {
        stateInfo.setError(stateInfo.getError() + tr("document_removed"));
    }
    return ReportResult_Finished;
}

}//namespace
