/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_DOT_PLOT_SPLITTER_H_
#define _GB2_DOT_PLOT_SPLITTER_H_

#include <util_ov_annotated_dna/ADVSplitWidget.h>

class QMenu;

namespace GB2 {

class GObjectView;
class DotPlotWidget;

class DotPlotSplitter : public ADVSplitWidget{
	Q_OBJECT

public:
	DotPlotSplitter(AnnotatedDNAView*);

	virtual bool acceptsGObject(GObject* objects) {Q_UNUSED(objects);return false;} 
	virtual void updateState(const QVariantMap&){};
	virtual void saveState(QVariantMap&){};

	void addView(DotPlotWidget*);
	void removeView(DotPlotWidget*);
	bool isEmpty() const;
	void buildPopupMenu(QMenu *);

private:
	QSplitter* splitter;
	QList<DotPlotWidget*> dotPlotList;
};

} // namespace

#endif // _GB2_DOT_PLOT_SPLITTER_H_
