/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_REMOTE_QUERY_PLUGIN_H_
#define _GB2_REMOTE_QUERY_PLUGIN_H_

#include <core_api/PluginModel.h>
#include <core_api/ObjectViewModel.h>
#include <core_api/AppContext.h>

#include "RemoteQueryPluginTests.h"
#include "SendSelectionDialog.h"
#include "RemoteQueryTask.h"
#include "RemoteQueryWorker.h"
#include "DBRequestFactory.h"

namespace GB2 {

class XMLTestFactory;
class RemoteQueryViewContext;

class RemoteQueryPlugin : public Plugin  {
    Q_OBJECT
public:
    RemoteQueryPlugin();
private:
    RemoteQueryViewContext * ctx;
};

class RemoteQueryViewContext : public GObjectViewWindowContext {
    Q_OBJECT
public:
    RemoteQueryViewContext(QObject * p);
protected:
    virtual void initViewContext( GObjectView* view );
private slots:
    void sl_showDialog();
};

class RemoteQueryPluginTests {
public:
    static QList<XMLTestFactory*> createTestFactories();
};

}


#endif
