/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_WEIGHTMATRIX_PLUGIN_H_
#define _GB2_WEIGHTMATRIX_PLUGIN_H_

#include <core_api/PluginModel.h>
#include <core_api/ObjectViewModel.h>

#include <QtGui/QMenu>

namespace GB2 {

class WeightMatrixADVContext;
class XMLTestFactory;

class WeightMatrixPlugin : public Plugin {
    Q_OBJECT
public:
    WeightMatrixPlugin();
    ~WeightMatrixPlugin();
protected slots:
    void sl_build();

private:
    WeightMatrixADVContext*                  ctxADV;
};

class WeightMatrixADVContext: public GObjectViewWindowContext {
    Q_OBJECT
public:
    WeightMatrixADVContext(QObject* p);

protected slots:
    void sl_search();

protected:
    virtual void initViewContext(GObjectView* view);
};

class WeightMatrixAlgorithmTests {
public:
    static QList<XMLTestFactory*> createTestFactories();
};

} //namespace

#endif
