##################################################################
# Unipro UGENE - Integrated Bioinformatics Suite
# Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
# All Rights Reserved
# 
#
#     This source code is distributed under the terms of the
#     GNU General Public License. See the files COPYING and LICENSE
#     for details.
##################################################################

include (workflow_designer.pri)

# Input
HEADERS += src/ActorCfgModel.h \
           src/ChooseItemDialog.h \
           src/GlassView.h \
           src/ItemViewStyle.h \
           src/IterationListWidget.h \
           src/SceneSerializer.h \
           src/SchemaConfigurationDialog.h \
           src/WorkflowDesignerPlugin.h \
           src/WorkflowDocument.h \
           src/WorkflowEditor.h \
           src/WorkflowEditorDelegates.h \
           src/WorkflowMetaDialog.h \
           src/WorkflowPalette.h \
           src/WorkflowSamples.h \
           src/WorkflowSceneTasks.h \
           src/WorkflowSettingsController.h \
           src/WorkflowViewController.h \
           src/WorkflowViewItems.h \
           src/SchemaAliasesConfigurationDialogImpl.h \
           src/library/BaseDocWorker.h \
           src/library/CoreLib.h \
           src/library/DocActors.h \
           src/library/DocWorkers.h \
           src/library/FindWorker.h \
           src/library/GenericReadActor.h \
           src/library/GenericReadWorker.h \
           src/library/SequenceSplitWorker.h \
           src/library/SWWorker.h \
           src/wd_local_task/WorkflowSimpleLocalTask.h \
           src/tests/WorkflowTests.h \
           src/cmdline/WorkflowCMDLineTasks.h

FORMS +=   src/ui/ChooseItemDialog.ui \
           src/ui/SchemaConfigurationDialog.ui \
           src/ui/WorkflowEditorWidget.ui \
           src/ui/WorkflowMetaDialog.ui \
           src/ui/WorkflowSettingsWidget.ui \
           src/ui/SchemaAliasesConfigurationDialog.ui

SOURCES += src/ActorCfgModel.cpp \
           src/ChooseItemDialog.cpp \
           src/GlassView.cpp \
           src/ItemViewStyle.cpp \
           src/IterationListWidget.cpp \
           src/SceneSerializer.cpp \
           src/SchemaConfigurationDialog.cpp \
           src/WorkflowDesignerPlugin.cpp \
           src/WorkflowDocument.cpp \
           src/WorkflowEditor.cpp \
           src/WorkflowEditorDelegates.cpp \
           src/WorkflowMetaDialog.cpp \
           src/WorkflowPalette.cpp \
           src/WorkflowSamples.cpp \
           src/WorkflowSceneTasks.cpp \
           src/WorkflowSettingsController.cpp \
           src/WorkflowViewController.cpp \
           src/WorkflowViewItems.cpp \
           src/SchemaAliasesConfigurationDialogImpl.cpp \
           src/library/BaseDocWorker.cpp \
           src/library/CoreLib.cpp \
           src/library/DocActors.cpp \
           src/library/DocWorkers.cpp \
           src/library/FindWorker.cpp \
           src/library/GenericReadActor.cpp \
           src/library/GenericReadWorker.cpp \
           src/library/SequenceSplitWorker.cpp \
           src/library/SWWorker.cpp \
           src/wd_local_task/WorkflowSimpleLocalTask.cpp \
           src/tests/WorkflowTests.cpp \
           src/cmdline/WorkflowCMDLineTasks.cpp

RESOURCES += workflow_designer.qrc
TRANSLATIONS += transl/english.ts transl/russian.ts
